#if defined(__linux__)
#if defined(__i386__)

/*
 * Use Linux system call.
 */

#define SYS_exit   1
#define SYS_read   3
#define SYS_write  4
#define SYS_open   5
#define SYS_close  6
#define SYS_ioctl 54

	.section .text

	.globl	_exit
	.type	_exit, @function
_exit:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_exit, %eax
	jmp	_syscall

	.globl	read
	.type	read, @function
read:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_read, %eax
	jmp	_syscall

	.globl	write
	.type	write, @function
write:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_write, %eax
	jmp	_syscall

	.globl	open
	.type	open, @function
open:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_open, %eax
	jmp	_syscall

	.globl	close
	.type	close, @function
close:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_close, %eax
	jmp	_syscall

	.globl	ioctl
	.type	ioctl, @function
ioctl:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_ioctl, %eax
	jmp	_syscall

_syscall:
	int	$0x80
	pop	%ebx
	cmpl	$0, %eax
	jns	ret
err:	neg	%eax
	mov	%eax, errno 
	mov	$-1, %eax
ret:	ret
#endif
#endif
